.\" Automatically generated from an mdoc input file.  Do not edit.
.\" Copyright (c) 2003-2018 Dieter Baron and Thomas Klausner.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above
.\"    copyright notice, this list of conditions and the following
.\"    disclaimer in the documentation and/or other materials provided
.\"    with the distribution.
.\" 3. The name of the author may not be used to endorse or promote
.\"    products derived from this software without specific prior
.\"    written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THOMAS KLAUSNER ``AS IS'' AND ANY
.\" EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR
.\" CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
.\" SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
.\" LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
.\" USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
.\" ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
.\" OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
.\" OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.TH "CKMAME" "1" "May 6, 2021" "NiH" "General Commands Manual"
.nh
.if n .ad l
.SH "NAME"
\fBckmame\fR
\- verify MAME ROM sets
.SH "SYNOPSIS"
.HP 7n
\fBckmame\fR
[\fB\-bCcdFfhjKkLlSsuVvwX\fR]
[\fB\-D\fR\ \fIdbfile\fR]
[\fB\-e\fR\ \fIdir\fR]
[\fB\-O\fR\ \fIdbfile\fR]
[\fB\-R\fR\ \fIdir\fR]
[\fB\-T\fR\ \fIfile\fR]
[\fB\-\fR\fB\-autofixdat\fR]
[\fB\-\fR\fB\-cleanup-extra\fR]
[\fB\-\fR\fB\-correct\fR]
[\fB\-\fR\fB\-db\fR\ \fIdbfile\fR]
[\fB\-\fR\fB\-delete-duplicate\fR]
[\fB\-\fR\fB\-delete-found\fR]
[\fB\-\fR\fB\-delete-long\fR]
[\fB\-\fR\fB\-delete-unknown\fR]
[\fB\-\fR\fB\-fix\fR]
[\fB\-\fR\fB\-fixdat\fR\ \fIfile\fR]
[\fB\-\fR\fB\-games-from\fR\ \fIfile\fR]
[\fB\-\fR\fB\-help\fR]
[\fB\-\fR\fB\-ignore-extra\fR]
[\fB\-\fR\fB\-ignore-unknown\fR]
[\fB\-\fR\fB\-keep-duplicate\fR]
[\fB\-\fR\fB\-keep-found\fR]
[\fB\-\fR\fB\-move-long\fR]
[\fB\-\fR\fB\-move-unknown\fR]
[\fB\-\fR\fB\-nobroken\fR]
[\fB\-\fR\fB\-nofixable\fR]
[\fB\-\fR\fB\-nonogooddumps\fR]
[\fB\-\fR\fB\-nosuperfluous\fR]
[\fB\-\fR\fB\-nowarnings\fR]
[\fB\-\fR\fB\-old-db\fR\ \fIdbfile\fR]
[\fB\-\fR\fB\-rom-dir\fR\ \fIdir\fR]
[\fB\-\fR\fB\-roms-unzipped\fR]
[\fB\-\fR\fB\-search\fR\ \fIdir\fR]
[\fB\-\fR\fB\-stats\fR]
[\fB\-\fR\fB\-superfluous\fR]
[\fB\-\fR\fB\-verbose\fR]
[\fB\-\fR\fB\-version\fR]
[\fIgame\ ...\fR]
.SH "DESCRIPTION"
\fBckmame\fR
is a program to check ROM sets for MAME, the Multiple Arcade
Machine Emulator (see
\fIhttp://www.mame.net/\fR),
or other emulators that provide ROM set information in a compatible
way (e.g., Raine, Impact, or other emulators).
This is the same format as clrmamepro dat files.
\fBckmame\fR
tells you which ROM files are missing or have a wrong checksum,
can delete unknown and unused files from the ROM sets, and rename
or move files.
.PP
MAME is an emulator for numerous arcade machines (video games, ranging
from the 1970s to today).
Since MAME is emulating the games, it uses the original images from
the arcade machines' original ROM chips.
MAME's internal database contains extensive information on the
ROMs, including the sizes and checksums of the used ROMs.
Since some arcade games are variants of others and share some of the
same ROMs, there are also internal dependencies between these so
called clones.
To save space, ROMs can be archived in zip files and
dynamically unzipped by MAME when you play a game.
\fBckmame\fR
does only support ROM sets stored as zip files.
.PP
\fBckmame\fR
tries to create a
\(lqsplit ROM set\(rq
from your current collection.
This means that all files needed by the parent are kept in the
parent's zip file, and only the files needed by the clone (or child)
that are different from the parent's are kept in the child's zip file.
For identifying the ROMs ckmame uses the sizes and checksums; names are
only used for verification, since the MAME team often renames ROMs.
.PP
While
\fBckmame\fR
uses MAME's ROM database, it must be converted into a more
efficient format before use.
See
mkmamedb(1)
for details.
.PP
By default,
\fBckmame\fR
will check the games named on the command line, or all games if none
are given.
Shell wildcards are allowed.
You can use command line options to select which type of errors to report.
.SS "OPTIONS"
Supported options:
.TP 24n
\fB\-\fR\fB\-autofixdat\fR
Like
\fB\-\fR\fB\-fixdat\fR,
but automatically generates the output file name from the datfile's
name and version number:
\(lq\fIfix_$SYSTEM ($VERSION).dat\fR\(rq.
.TP 24n
\fB\-b,\fR \fB\-\fR\fB\-nobroken\fR
Don't report unfixable errors.
See also
\fB\-f\fR
and
\fB\-w\fR.
.TP 24n
\fB\-\fR\fB\-cleanup-extra\fR
Remove files already in ROM set from extra directories.
.TP 24n
\fB\-C\fR, \fB\-\fR\fB\-complete-only\fR
Only create complete sets.
ROMs for incomplete sets are moved to the
\fIneeded\fR
directory.
.TP 24n
\fB\-c\fR, \fB\-\fR\fB\-correct\fR
Report correct sets.
Normally they are not mentioned.
.TP 24n
\fB\-D\fR \fIdbfile\fR, \fB\-\fR\fB\-db\fR \fIdbfile\fR
Use
\fIdbfile\fR
as database file.
.TP 24n
\fB\-d\fR, \fB\-\fR\fB\-nonogooddumps\fR
Don't report ROMs with no known good dumps.
.TP 24n
\fB\-\fR\fB\-delete-duplicate\fR
Delete files present in old ROM database (default).
See also
\fB\-\fR\fB\-keep-duplicate\fR.
.TP 24n
\fB\-e\fR \fIdir\fR, \fB\-\fR\fB\-search\fR \fIdir\fR
.br
Look for missing files in directory
\fIdir\fR
and its subdirectories.
Recommended for use with update sets.
See also
\fB\-j\fR.
.TP 24n
\fB\-F\fR, \fB\-\fR\fB\-fix\fR
Fix ROM sets; do as much as possible, such as renaming and moving
files.
.TP 24n
\fB\-f\fR, \fB\-\fR\fB\-nofixable\fR
Don't report fixable errors.
See also
\fB\-b\fR
and
\fB\-w\fR.
.TP 24n
\fB\-\fR\fB\-fixdat\fR \fIname\fR
Create a clrmamepro-style
\(lqfixdat\(rq
file, i.e. an XML file containing only the files missing in the ROM
set compared to the database used.
.TP 24n
\fB\-h\fR, \fB\-\fR\fB\-help\fR
Display a short help message.
.TP 24n
\fB\-\fR\fB\-ignore-unknown\fR
Ignore unknown files when fixing.
They will still be reported.
.TP 24n
\fB\-j\fR, \fB\-\fR\fB\-delete-found\fR
When using
\fB\-e\fR,
delete files that are copied to the ROM set.
See also
\fB\-\fR\fB\-keep-found\fR.
.TP 24n
\fB\-\fR\fB\-keep-duplicate\fR
Keep files present in old ROM database.
See also
\fB\-\fR\fB\-delete-duplicate\fR.
.TP 24n
\fB\-\fR\fB\-keep-found\fR
When using
\fB\-e\fR,
do not remove files that are copied to the ROM set (default).
See also
\fB\-j\fR.
.TP 24n
\fB\-K\fR, \fB\-\fR\fB\-move-unknown\fR
Move unknown files when fixing (default).
They are moved into a zip file with the same name under
\fIroms/garbage\fR.
See also
\fB\-k\fR.
.TP 24n
\fB\-k\fR, \fB\-\fR\fB\-delete-unknown\fR
.br
Delete unknown files when fixing.
See also
\fB\-K\fR.
.TP 24n
\fB\-L\fR, \fB\-\fR\fB\-move-long\fR
Move too long files when fixing (default).
See also
\fB\-K\fR
and
\fB\-l\fR.
.TP 24n
\fB\-l\fR, \fB\-\fR\fB\-delete-long\fR
Delete long files when fixing.
See also
\fB\-L\fR.
.TP 24n
\fB\-O\fR \fIdbfile\fR, \fB\-\fR\fB\-old-db\fR \fIdbfile\fR
Assume that files listed in
\fIdbfile\fR
exist elsewhere.
.TP 24n
\fB\-R\fR \fIdir\fR, \fB\-\fR\fB\-rom-dir\fR \fIdir\fR
Look for roms in
\fIdir\fR.
Default is
\(lqroms\(rq.
.TP 24n
\fB\-\fR\fB\-stats\fR
Display completeness statistics of ROM set at end of run.
.TP 24n
\fB\-\fR\fB\-superfluous\fR
Only check for superfluous files in ROM sets.
.TP 24n
\fB\-s\fR, \fB\-\fR\fB\-nosuperfluous\fR
Don't report superfluous (unneeded) files.
.TP 24n
\fB\-T\fR \fIfile\fR, \fB\-\fR\fB\-games-from\fR \fIfile\fR
Read list of games to check from
\fIfile\fR.
.TP 24n
\fB\-u\fR, \fB\-\fR\fB\-roms-unzipped\fR
ROMs are files on the disk.
Each game is represented by a directory instead of a ZIP archive.
.TP 24n
\fB\-V\fR, \fB\-\fR\fB\-version\fR
Display program name and version number.
.TP 24n
\fB\-v\fR, \fB\-\fR\fB\-verbose\fR
Print fixes made.
Only useful with
\fB\-F\fR.
.TP 24n
\fB\-w\fR, \fB\-\fR\fB\-nowarnings\fR
Print only unfixable error, like missing or completely incorrect ROMs.
See also
\fB\-b\fR
and
\fB\-f\fR.
.TP 24n
\fB\-X\fR, \fB\-\fR\fB\-ignore-extra\fR
Do not mention extra files that are in the ROM dirs.
Most of the time these are ROM sets whose names have changed.
Additionally,
\fBckmame\fR
creates a
\fIroms/garbage\fR
directory (see also
\fB\-K\fR),
which you will also be warned about.
.SH "ENVIRONMENT"
.TP 12n
\fRMAMEDB\fR
Location for the database file.
Can be overridden with the
\fB\-D\fR
option.
Defaults to
\(lq\fImame.db\fR\(rq.
.TP 12n
\fRMAMEDB_OLD\fR
Location for the database file of files that exist elsewhere.
Can be overridden with the
\fB\-O\fR
option.
Defaults to
\(lq\fIold.db\fR\(rq.
.SH "FILES"
Unknown files are moved to the sub-directory
\fIunknown\fR.
Files that will be needed by other games in the ROM set are moved
to the
\fIneeded\fR
directory.
.PP
In unzipped mode
(\fB\-u\fR),
\fBckmame\fR
creates
\fI.ckmame.db\fR
files in the rom directory as well as the directories given with
\fB\-e\fR.
These files are databases containing file names, sizes, and their
hashes.
The database information used when the file hasn't changed
since the last run (i.e. same size and modification time).
.SH "EXAMPLES"
Print a report about the current state of your ROM sets in the
\fIroms\fR
subdir of the current dir:
.RS 6n
\fBckmame\fR
.RE
.PP
Fix all sets and only report unfixable errors, omitting those
ROMs where no good dump exists:
.RS 6n
\fBckmame -Fwd\fR
.RE
.PP
Fix all sets using the files found in
\fIupdatedir\fR,
removing files from there that are copied to the ROM set:
.RS 6n
\fBckmame -Fj -e updatedir\fR
.RE
.SH "DIAGNOSTICS"
Most messages should be straightforward.
Two need special explanations:
.PP
If a file is marked as
\(lqbroken\(rq,
it means that the computed checksum is not the same
as the checksum stored in the zip archive,
usually because there has been a decompression error.
.PP
If a ROM or disk is marked with
\(lqchecksum mismatch\(rq,
the primary checksum matches, but one of the other checksums
does not.
The primary checksum for ROMs is CRC32, for disks MD5.
.SH "SEE ALSO"
dumpgame(1),
mkmamedb(1)
.SH "AUTHORS"
\fBckmame\fR
was written by
Dieter Baron
\(ladillo@nih.at\(ra
and
Thomas Klausner
\(latk@giga.or.at\(ra.
